// ignore_for_file: non_constant_identifier_names, avoid_print, prefer_const_constructors

import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:manager_queue/cubit/queue_cubit.dart';
import 'package:manager_queue/cubit/ready_cubit.dart';
import 'package:manager_queue/helper/config.dart';
import 'package:manager_queue/main.dart';
import 'package:manager_queue/models/queue.dart';
import 'package:mqtt_client/mqtt_client.dart';
import 'package:http/http.dart' as http;

class MiddleWidget extends StatefulWidget {
  const MiddleWidget({Key? key}) : super(key: key);

  @override
  State<MiddleWidget> createState() => _MiddleWidgetState();
}

class _MiddleWidgetState extends State<MiddleWidget> {
  List clearData = [OrderQueue];

  Future setToClear() async {
    // print(readySelected);
    var apiUrl = apiUrlClear;
    final String? session_keys = prefs.getString('session_key');
    final String? userId = prefs.getString('user_id');
    // print(apiUrl);
    Map setClear = {"session_key": session_keys, "user_id": userId};
    var dataClear = jsonEncode(setClear);
    var apiResult = await http.post(Uri.parse(apiUrl), body: dataClear);
    var jsonObject = jsonDecode(apiResult.body)['status'];
    if (jsonObject == "ok") {
      context.read<ReadyCubit>().getData();
      context.read<QueueCubit>().getData();
      final pubTopic = queueTopic;
      final builder = MqttClientPayloadBuilder();
      builder.addString(queueMessage);
      mqClient.publishMessage(pubTopic, MqttQos.exactlyOnce, builder.payload!);
    } else {
      print("gabisa");
    }
  }

  @override
  Widget build(BuildContext context) {
    return Flexible(
      flex: 1,
      child: Container(
        width: MediaQuery.of(context).size.width * 0.2,
        height: MediaQuery.of(context).size.height * 1,
        color: Colors.blueGrey,
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: <Widget>[
            InkWell(
              onTap: () {
                // print("clear");
                showDialog(
                  context: context,
                  builder: (BuildContext context) => AlertDialog(
                    title: Text("Clear"),
                    content: Text("Are you sure to clear data?"),
                    actions: <Widget>[
                      TextButton(
                        onPressed: () => Navigator.pop(context),
                        child: Text('Cancel'),
                      ),
                      TextButton(
                        onPressed: () => Navigator.pop(context, setToClear()),
                        child: Text('OK'),
                      ),
                    ],
                  ),
                );
              },
              child: Container(
                width: MediaQuery.of(context).size.width * 0.18,
                height: MediaQuery.of(context).size.height * 0.07,
                margin: EdgeInsets.all(10),
                decoration: BoxDecoration(
                  borderRadius: BorderRadius.all(
                    Radius.circular(20),
                  ),
                  color: Colors.red,
                ),
                alignment: Alignment.center,
                child: Text(
                  "CLEAR",
                  style: GoogleFonts.openSans(
                      fontSize: 30, fontWeight: FontWeight.w700),
                ),
              ),
            ),
          ],
        ),
      ),
    );
  }
}
