// ignore_for_file: non_constant_identifier_names, unused_local_variable, sized_box_for_whitespace, prefer_const_constructors

import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:google_fonts/google_fonts.dart';
import 'package:manager_queue/cubit/queue_cubit.dart';
import 'package:manager_queue/cubit/ready_cubit.dart';
import 'package:manager_queue/helper/config.dart';
import 'package:manager_queue/helper/state.dart';
import 'package:manager_queue/main.dart';
import 'package:http/http.dart' as http;
import 'package:mqtt_client/mqtt_client.dart';

class OrderReadyWidget extends StatefulWidget {
  const OrderReadyWidget({Key? key}) : super(key: key);

  @override
  State<OrderReadyWidget> createState() => _OrderReadyWidgetState();
}

class _OrderReadyWidgetState extends State<OrderReadyWidget> {
  late List<String> readySelected = [];
  late List<String> pickUp = [];

  void setToQueue(List readySelecteds) async {
    // print(readySelected);
    var apiUrl = apiUrlUpdate;
    final String? session_keys = prefs.getString('session_key');
    final String? userId = prefs.getString('user_id');
    for (var i in readySelecteds) {
      Map setQueue = {
        "session_key": session_keys,
        "user_id": userId,
        "id": i.toString(),
        "status": 0
      };
      var dataQueue = jsonEncode(setQueue);
      var apiResult = await http.post(Uri.parse(apiUrl), body: dataQueue);
      var jsonObject = jsonDecode(apiResult.body)['status'];
      // if (jsonObject == true) {
      //   context.read<ReadyCubit>().getData();
      //   context.read<QueueCubit>().getData();
      // } else {
      //   print("tidak berhasil");
      // }
    }
    context.read<ReadyCubit>().getData();
    context.read<QueueCubit>().getData();
    final pubTopic = queueTopic;
    final builder = MqttClientPayloadBuilder();
    builder.addString(queueMessage);
    mqClient.publishMessage(pubTopic, MqttQos.exactlyOnce, builder.payload!);
    readySelected = [];
  }

  // void setToPickUp(List<OrderQueue> readySelected) {
  //   for (var i in readySelected) {
  //     orderReady.remove(i);
  //   }

  //   pickUp.addAll(readySelected);
  // }

  void setToPickUp(List readySelecteds) async {
    // print(readySelecteds);
    var apiUrl = apiUrlUpdate;
    final String? session_keys = prefs.getString('session_key');
    final String? userId = prefs.getString('user_id');
    for (var i in readySelecteds) {
      Map setPickUp = {
        "session_key": session_keys,
        "user_id": userId,
        "id": i.toString(),
        "status": 2
      };
      var dataPickUp = jsonEncode(setPickUp);
      var apiResult = await http.post(Uri.parse(apiUrl), body: dataPickUp);
      var jsonObject = jsonDecode(apiResult.body)['status'];
      // if (jsonObject == true) {
      //   context.read<ReadyCubit>().getData();
      //   context.read<QueueCubit>().getData();
      // } else {
      //   print("tidak berhasil");
      // }

    }
    context.read<ReadyCubit>().getData();
    context.read<QueueCubit>().getData();
    final pubTopic = queueTopic;
    final builder = MqttClientPayloadBuilder();
    builder.addString(queueMessage);
    mqClient.publishMessage(pubTopic, MqttQos.exactlyOnce, builder.payload!);
    readySelected = [];
  }

  @override
  Widget build(BuildContext context) {
    return Flexible(
      flex: 2,
      child: Container(
        color: Colors.black12,
        child: Column(
          mainAxisAlignment: MainAxisAlignment.spaceBetween,
          children: <Widget>[
            Container(
              width: MediaQuery.of(context).size.width * 0.4,
              height: MediaQuery.of(context).size.height * 0.1,
              color: Colors.lightGreen,
              alignment: Alignment.center,
              child: Text(
                "READY",
                style: GoogleFonts.openSans(
                    fontSize: 30, fontWeight: FontWeight.w700),
              ),
            ),
            Container(
              width: MediaQuery.of(context).size.width * 0.38,
              height: MediaQuery.of(context).size.height * 0.75,
              child: MediaQuery.removePadding(
                context: context,
                removeTop: true,
                child: BlocConsumer<ReadyCubit, ReadyState>(
                  listener: (context, state) {
                    // print('listener');
                    // print(state);
                  },
                  builder: (context, state) {
                    if (state is ReadyLoading) {
                      // return CircularProgressIndicator();
                      return SizedBox();
                    } else if (state is ReadyLoaded) {
                      return GridView.builder(
                        itemCount: state.readys.length,
                        gridDelegate:
                            const SliverGridDelegateWithFixedCrossAxisCount(
                                crossAxisCount: 2,
                                crossAxisSpacing: 10,
                                mainAxisSpacing: 5,
                                childAspectRatio: 2),
                        itemBuilder: (BuildContext context, int index) {
                          var thisQueue = state.readys[index];
                          return Material(
                            borderRadius: BorderRadius.circular(10),
                            child: InkWell(
                              onTap: () {
                                context
                                    .read<ReadyCubit>()
                                    .onPressed(state.readys, thisQueue);
                              },
                              child: Card(
                                  color: cardColor,
                                  shape: RoundedRectangleBorder(
                                    borderRadius: BorderRadius.circular(10),
                                  ),
                                  child: Center(
                                      child: Text(
                                    "Pesanan " + thisQueue.queue_number,
                                    style: GoogleFonts.openSans(fontSize: 20),
                                  ))),
                            ),
                          );
                        },
                      );
                    } else if (state is ReadyUpdated) {
                      return GridView.builder(
                        itemCount: state.readys.length,
                        gridDelegate:
                            const SliverGridDelegateWithFixedCrossAxisCount(
                                crossAxisCount: 2,
                                crossAxisSpacing: 10,
                                mainAxisSpacing: 5,
                                childAspectRatio: 2),
                        itemBuilder: (BuildContext context, int index) {
                          var thisQueue = state.readys[index];
                          if (thisQueue.isSelectedReady) {
                            if (!readySelected.contains(thisQueue.id)) {
                              readySelected.add(thisQueue.id);
                            }
                          } else {
                            readySelected.remove(thisQueue.id);
                          }
                          return Material(
                            borderRadius: BorderRadius.circular(10),
                            child: InkWell(
                              onTap: () {
                                context
                                    .read<ReadyCubit>()
                                    .onPressed(state.readys, thisQueue);
                              },
                              child: Card(
                                  color: thisQueue.isSelectedReady
                                      ? Colors.blue
                                      : cardColor,
                                  shape: RoundedRectangleBorder(
                                    borderRadius: BorderRadius.circular(10),
                                  ),
                                  child: Center(
                                      child: Text(
                                    "Pesanan " + thisQueue.queue_number,
                                    style: GoogleFonts.openSans(fontSize: 20),
                                  ))),
                            ),
                          );
                        },
                      );
                    } else {
                      return SizedBox();
                    }
                  },
                ),
              ),
            ),
            Row(
              children: [
                Flexible(
                  flex: 1,
                  child: InkWell(
                    onTap: () {
                      setToQueue(readySelected);
                    },
                    child: Container(
                      width: MediaQuery.of(context).size.width * 0.2,
                      height: MediaQuery.of(context).size.height * 0.1,
                      color: Colors.lightGreen,
                      alignment: Alignment.center,
                      child: InkWell(
                        onTap: () => setToQueue(readySelected),
                        child: Text(
                          "SET TO QUEUE",
                          style: GoogleFonts.openSans(
                              fontSize: 30, fontWeight: FontWeight.w700),
                        ),
                      ),
                    ),
                  ),
                ),
                Flexible(
                  flex: 1,
                  child: InkWell(
                    onTap: () {
                      setToPickUp(readySelected);
                    },
                    child: Container(
                      width: MediaQuery.of(context).size.width * 0.2,
                      height: MediaQuery.of(context).size.height * 0.1,
                      color: Colors.black26,
                      alignment: Alignment.center,
                      child: InkWell(
                        onTap: () => setToPickUp(readySelected),
                        child: Text(
                          "PICK UP",
                          style: GoogleFonts.openSans(
                              fontSize: 30, fontWeight: FontWeight.w700),
                        ),
                      ),
                    ),
                  ),
                ),
              ],
            ),
          ],
        ),
      ),
    );
  }
}
